Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Interval.cs	(revision 17409)
@@ -37,5 +37,27 @@
     protected Interval(StorableConstructorFlag _) { }
 
+    /// <summary>
+    /// Creates an interval with given bounds, where lower bound must be smaller than
+    /// the upper bound. Floating point precision errors trough calculations are fixed by,
+    /// checking if the intervals are almost the same (E-12). If this is the case, the bounds 
+    /// will be set to the bound closer to zero.
+    /// </summary>
+    /// <param name="lowerBound">Lower bound of the interval</param>
+    /// <param name="upperBound">Upper bound of the interval</param>
     public Interval(double lowerBound, double upperBound) {
+      if (lowerBound.IsAlmost(upperBound)) {
+        //If the bounds go over zero
+        if (lowerBound <= 0 && upperBound >= 0) {
+          lowerBound = 0.0;
+          upperBound = 0.0;
+          //Interval is negative
+        } else if (upperBound < 0) {
+          lowerBound = upperBound;
+          //Interval is positive
+        } else {
+          upperBound = lowerBound;
+        }
+      }
+
       if (lowerBound > upperBound)
         throw new ArgumentException("LowerBound must be smaller than UpperBound.");
@@ -58,4 +80,18 @@
                 double.IsNaN(LowerBound) || double.IsNaN(UpperBound);
       }
+    }
+
+    /// <summary>
+    /// True if the interval is positive without zero
+    /// </summary>
+    public bool IsPositive {
+      get => LowerBound > 0.0; 
+    }
+
+    /// <summary>
+    /// True if the interval is negative without zero
+    /// </summary>
+    public bool IsNegative {
+      get => UpperBound < 0.0;
     }
 
@@ -128,5 +164,5 @@
     }
 
-    //mkommend: Division by intervals containing 0 is implemented as defined in
+    //Division by intervals containing 0 is implemented as defined in
     //http://en.wikipedia.org/wiki/Interval_arithmetic
     public static Interval Divide(Interval a, Interval b) {
@@ -171,5 +207,5 @@
     public static Interval Tangens(Interval a) {
       return Interval.Divide(Interval.Sine(a), Interval.Cosine(a));
-    }  
+    }
     public static Interval HyperbolicTangent(Interval a) {
       return new Interval(Math.Tanh(a.LowerBound), Math.Tanh(a.UpperBound));
@@ -226,6 +262,30 @@
 
     public static Interval CubicRoot(Interval a) {
-      if (a.LowerBound < 0) return new Interval(double.NaN, double.NaN);
-      return new Interval(Math.Pow(a.LowerBound, 1.0 / 3), Math.Pow(a.UpperBound, 1.0 / 3));
+      var lower = (a.LowerBound < 0) ? -Math.Pow(-a.LowerBound, 1d / 3d) : Math.Pow(a.LowerBound, 1d / 3d);
+      var upper = (a.UpperBound < 0) ? -Math.Pow(-a.UpperBound, 1d / 3d) : Math.Pow(a.UpperBound, 1d / 3d);
+
+      return new Interval(lower, upper);
+    }
+
+    public static Interval Absolute(Interval a) {
+      var absLower = Math.Abs(a.LowerBound);
+      var absUpper = Math.Abs(a.UpperBound);
+      var min = Math.Min(absLower, absUpper);
+      var max = Math.Max(absLower, absUpper);
+
+      if (a.Contains(0.0)) {
+        min = 0.0;
+      }
+
+      return new Interval(min, max);
+    }
+
+    public static Interval AnalyticalQuotient(Interval a, Interval b) {
+      var dividend = a;
+      var divisor = Add(Square(b), new Interval(1.0, 1.0));
+      divisor = SquareRoot(divisor);
+
+      var quotient = Divide(dividend, divisor);
+      return quotient;
     }
     #endregion
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.Designer.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.Designer.cs	(revision 17409)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.Designer.cs	(revision 17409)
@@ -0,0 +1,212 @@
+﻿namespace HeuristicLab.Scripting.Views {
+  partial class CompilerErrorDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.iconLabel = new System.Windows.Forms.Label();
+      this.detailsGroupBox = new System.Windows.Forms.GroupBox();
+      this.codeValueLinkLabel = new System.Windows.Forms.LinkLabel();
+      this.messageLabel = new System.Windows.Forms.Label();
+      this.codeLabel = new System.Windows.Forms.Label();
+      this.columnValueLabel = new System.Windows.Forms.Label();
+      this.columnLabel = new System.Windows.Forms.Label();
+      this.lineValueLabel = new System.Windows.Forms.Label();
+      this.lineLabel = new System.Windows.Forms.Label();
+      this.messageValueTextBox = new System.Windows.Forms.TextBox();
+      this.infoTextBox = new System.Windows.Forms.TextBox();
+      this.okButton = new System.Windows.Forms.Button();
+      this.detailsGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // iconLabel
+      // 
+      this.iconLabel.Location = new System.Drawing.Point(12, 9);
+      this.iconLabel.Name = "iconLabel";
+      this.iconLabel.Size = new System.Drawing.Size(30, 30);
+      this.iconLabel.TabIndex = 1;
+      // 
+      // detailsGroupBox
+      // 
+      this.detailsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.detailsGroupBox.Controls.Add(this.codeValueLinkLabel);
+      this.detailsGroupBox.Controls.Add(this.messageLabel);
+      this.detailsGroupBox.Controls.Add(this.codeLabel);
+      this.detailsGroupBox.Controls.Add(this.columnValueLabel);
+      this.detailsGroupBox.Controls.Add(this.columnLabel);
+      this.detailsGroupBox.Controls.Add(this.lineValueLabel);
+      this.detailsGroupBox.Controls.Add(this.lineLabel);
+      this.detailsGroupBox.Controls.Add(this.messageValueTextBox);
+      this.detailsGroupBox.Location = new System.Drawing.Point(12, 42);
+      this.detailsGroupBox.Name = "detailsGroupBox";
+      this.detailsGroupBox.Size = new System.Drawing.Size(560, 212);
+      this.detailsGroupBox.TabIndex = 3;
+      this.detailsGroupBox.TabStop = false;
+      this.detailsGroupBox.Text = "Details";
+      // 
+      // codeValueLinkLabel
+      // 
+      this.codeValueLinkLabel.AutoSize = true;
+      this.codeValueLinkLabel.Location = new System.Drawing.Point(65, 65);
+      this.codeValueLinkLabel.Name = "codeValueLinkLabel";
+      this.codeValueLinkLabel.Size = new System.Drawing.Size(21, 13);
+      this.codeValueLinkLabel.TabIndex = 5;
+      this.codeValueLinkLabel.TabStop = true;
+      this.codeValueLinkLabel.Text = "{0}";
+      this.codeValueLinkLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.codeLinkLabel_LinkClicked);
+      // 
+      // messageLabel
+      // 
+      this.messageLabel.AutoSize = true;
+      this.messageLabel.Location = new System.Drawing.Point(6, 88);
+      this.messageLabel.Name = "messageLabel";
+      this.messageLabel.Size = new System.Drawing.Size(53, 13);
+      this.messageLabel.TabIndex = 6;
+      this.messageLabel.Text = "Message:";
+      // 
+      // codeLabel
+      // 
+      this.codeLabel.AutoSize = true;
+      this.codeLabel.Location = new System.Drawing.Point(6, 65);
+      this.codeLabel.Name = "codeLabel";
+      this.codeLabel.Size = new System.Drawing.Size(35, 13);
+      this.codeLabel.TabIndex = 4;
+      this.codeLabel.Text = "Code:";
+      // 
+      // columnValueLabel
+      // 
+      this.columnValueLabel.AutoSize = true;
+      this.columnValueLabel.Location = new System.Drawing.Point(65, 42);
+      this.columnValueLabel.Name = "columnValueLabel";
+      this.columnValueLabel.Size = new System.Drawing.Size(21, 13);
+      this.columnValueLabel.TabIndex = 3;
+      this.columnValueLabel.Text = "{0}";
+      // 
+      // columnLabel
+      // 
+      this.columnLabel.AutoSize = true;
+      this.columnLabel.Location = new System.Drawing.Point(6, 42);
+      this.columnLabel.Name = "columnLabel";
+      this.columnLabel.Size = new System.Drawing.Size(45, 13);
+      this.columnLabel.TabIndex = 2;
+      this.columnLabel.Text = "Column:";
+      // 
+      // lineValueLabel
+      // 
+      this.lineValueLabel.AutoSize = true;
+      this.lineValueLabel.Location = new System.Drawing.Point(65, 19);
+      this.lineValueLabel.Name = "lineValueLabel";
+      this.lineValueLabel.Size = new System.Drawing.Size(21, 13);
+      this.lineValueLabel.TabIndex = 1;
+      this.lineValueLabel.Text = "{0}";
+      // 
+      // lineLabel
+      // 
+      this.lineLabel.AutoSize = true;
+      this.lineLabel.Location = new System.Drawing.Point(6, 19);
+      this.lineLabel.Name = "lineLabel";
+      this.lineLabel.Size = new System.Drawing.Size(30, 13);
+      this.lineLabel.TabIndex = 0;
+      this.lineLabel.Text = "Line:";
+      // 
+      // messageValueTextBox
+      // 
+      this.messageValueTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.messageValueTextBox.BackColor = System.Drawing.SystemColors.Control;
+      this.messageValueTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
+      this.messageValueTextBox.Location = new System.Drawing.Point(68, 88);
+      this.messageValueTextBox.Multiline = true;
+      this.messageValueTextBox.Name = "messageValueTextBox";
+      this.messageValueTextBox.ReadOnly = true;
+      this.messageValueTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
+      this.messageValueTextBox.Size = new System.Drawing.Size(486, 118);
+      this.messageValueTextBox.TabIndex = 7;
+      this.messageValueTextBox.Text = "{0}";
+      // 
+      // infoTextBox
+      // 
+      this.infoTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.infoTextBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
+      this.infoTextBox.Cursor = System.Windows.Forms.Cursors.Default;
+      this.infoTextBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.infoTextBox.Location = new System.Drawing.Point(48, 17);
+      this.infoTextBox.Name = "infoTextBox";
+      this.infoTextBox.ReadOnly = true;
+      this.infoTextBox.Size = new System.Drawing.Size(524, 13);
+      this.infoTextBox.TabIndex = 2;
+      this.infoTextBox.Text = "{0} was generated during compilation.";
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Location = new System.Drawing.Point(497, 260);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 0;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      // 
+      // CompilerErrorDialog
+      // 
+      this.AcceptButton = this.okButton;
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.CancelButton = this.okButton;
+      this.ClientSize = new System.Drawing.Size(584, 295);
+      this.Controls.Add(this.okButton);
+      this.Controls.Add(this.infoTextBox);
+      this.Controls.Add(this.detailsGroupBox);
+      this.Controls.Add(this.iconLabel);
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "CompilerErrorDialog";
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+      this.Text = "{0}";
+      this.detailsGroupBox.ResumeLayout(false);
+      this.detailsGroupBox.PerformLayout();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label iconLabel;
+    private System.Windows.Forms.GroupBox detailsGroupBox;
+    private System.Windows.Forms.TextBox messageValueTextBox;
+    private System.Windows.Forms.Label lineLabel;
+    private System.Windows.Forms.Label columnLabel;
+    private System.Windows.Forms.Label lineValueLabel;
+    private System.Windows.Forms.Label codeLabel;
+    private System.Windows.Forms.Label columnValueLabel;
+    private System.Windows.Forms.LinkLabel codeValueLinkLabel;
+    private System.Windows.Forms.Label messageLabel;
+    private System.Windows.Forms.TextBox infoTextBox;
+    private System.Windows.Forms.Button okButton;
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.cs	(revision 17409)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/CompilerErrorDialog.cs	(revision 17409)
@@ -0,0 +1,34 @@
+﻿using System.CodeDom.Compiler;
+using System.Diagnostics;
+using System.Drawing;
+using System.Windows.Forms;
+using HeuristicLab.Common.Resources;
+
+namespace HeuristicLab.Scripting.Views {
+  public partial class CompilerErrorDialog : Form {
+    private const string ErrorLinkFormatString = "https://docs.microsoft.com/en-us/search/?search={0}&scope=.NET";
+
+    private static readonly Bitmap WarningImage = VSImageLibrary.Warning;
+    private static readonly Bitmap ErrorImage = VSImageLibrary.Error;
+
+    public CompilerErrorDialog(CompilerError error) {
+      InitializeComponent();
+
+      var image = error.IsWarning ? WarningImage : ErrorImage;
+
+      Icon = Icon.FromHandle(image.GetHicon());
+      Text = error.IsWarning ? "Warning" : "Error";
+      iconLabel.Image = image;
+      infoTextBox.Text = string.Format(infoTextBox.Text, error.IsWarning ? "A warning" : "An error");
+      lineValueLabel.Text = error.Line.ToString();
+      columnValueLabel.Text = error.Column.ToString();
+      codeValueLinkLabel.Text = error.ErrorNumber;
+      codeValueLinkLabel.Links.Add(new LinkLabel.Link(0, error.ErrorNumber.Length, string.Format(ErrorLinkFormatString, error.ErrorNumber)));
+      messageValueTextBox.Text = error.ErrorText;
+    }
+
+    private void codeLinkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
+      Process.Start((string)e.Link.LinkData);
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/HeuristicLab.Scripting.Views-3.3.csproj	(revision 17409)
@@ -97,4 +97,10 @@
     <Compile Include="CSharpScriptView.Designer.cs">
       <DependentUpon>CSharpScriptView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="CompilerErrorDialog.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="CompilerErrorDialog.Designer.cs">
+      <DependentUpon>CompilerErrorDialog.cs</DependentUpon>
     </Compile>
     <Compile Include="ExecutableScriptView.cs">
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 17409)
@@ -184,4 +184,5 @@
       this.errorListView.UseCompatibleStateImageBehavior = false;
       this.errorListView.View = System.Windows.Forms.View.Details;
+      this.errorListView.MouseClick += new System.Windows.Forms.MouseEventHandler(this.errorListView_MouseClick);
       this.errorListView.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.errorListView_MouseDoubleClick);
       // 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting.Views/3.3/ScriptView.cs	(revision 17409)
@@ -209,11 +209,23 @@
     }
 
+    private void errorListView_MouseClick(object sender, MouseEventArgs e) {
+      if (e.Button != MouseButtons.Left) return;
+
+      var item = errorListView.SelectedItems[0];
+      var message = (CompilerError)item.Tag;
+
+      codeEditor.ScrollToPosition(message.Line, message.Column);
+      codeEditor.Focus();
+    }
+
     private void errorListView_MouseDoubleClick(object sender, MouseEventArgs e) {
-      if (e.Button == MouseButtons.Left) {
-        var item = errorListView.SelectedItems[0];
-        var message = (CompilerError)item.Tag;
-        codeEditor.ScrollToPosition(message.Line, message.Column);
-        codeEditor.Focus();
-      }
+      if (e.Button != MouseButtons.Left) return;
+
+      var item = errorListView.SelectedItems[0];
+      var message = (CompilerError)item.Tag;
+
+      using (var dialog = new CompilerErrorDialog(message)) {
+        dialog.ShowDialog(this);
+      };
     }
     #endregion
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting/3.3/Script.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting/3.3/Script.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Scripting/3.3/Script.cs	(revision 17409)
@@ -40,4 +40,5 @@
   public abstract class Script : NamedItem, IProgrammableItem {
     #region Fields & Properties
+    public static readonly HashSet<string> ExcludedAssemblyFileNames = new HashSet<string> { "IKVM.OpenJDK.ClassLibrary.dll" };
     public static new Image StaticItemImage {
       get { return VSImageLibrary.Script; }
@@ -124,5 +125,6 @@
     public virtual IEnumerable<Assembly> GetAssemblies() {
       var assemblies = AppDomain.CurrentDomain.GetAssemblies()
-        .Where(a => !a.IsDynamic && File.Exists(a.Location))
+        .Where(a => !a.IsDynamic && File.Exists(a.Location)
+                 && !ExcludedAssemblyFileNames.Contains(Path.GetFileName(a.Location)))
         .GroupBy(x => Regex.Replace(Path.GetFileName(x.Location), @"-[\d.]+\.dll$", ""))
         .Select(x => x.OrderByDescending(y => y.GetName().Version).First())
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 17409)
@@ -665,7 +665,9 @@
             bool oldIsAllowedToCalculate = slave.IsAllowedToCalculate;
             Guid? oldParentResourceId = slave.ParentResourceId;
+            bool? oldIsDisposable = slave.IsDisposable;
             slaveInfo.CopyToEntity(slave);
             slave.IsAllowedToCalculate = oldIsAllowedToCalculate;
             slave.ParentResourceId = oldParentResourceId;
+            slave.IsDisposable = oldIsDisposable;
             slave.LastHeartbeat = DateTime.Now;
             slave.SlaveState = DA.SlaveState.Idle;
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/IntervalTest.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/IntervalTest.cs	(revision 17408)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis-3.4/IntervalTest.cs	(revision 17409)
@@ -14,5 +14,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalAddOperation() {
+    public void AddIntervalTest() {
       //add        [x1,x2] + [y1,y2] = [x1 + y1,x2 + y2]
 
@@ -28,5 +28,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalSubOperation() {
+    public void SubtractIntervalTest() {
       //subtract   [x1,x2] − [y1,y2] = [x1 − y2,x2 − y1]
 
@@ -42,5 +42,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalMutlipyOperation() {
+    public void MultiplyIntervalTest() {
       //multiply   [x1,x2] * [y1,y2] = [min(x1*y1,x1*y2,x2*y1,x2*y2),max(x1*y1,x1*y2,x2*y1,x2*y2)]
 
@@ -59,5 +59,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalDivideOperation() {
+    public void DivideIntervalTest() {
       //divide  [x1, x2] / [y1, y2] = [x1, x2] * (1/[y1, y2]), where 1 / [y1,y2] = [1 / y2,1 / y1] if 0 not in [y_1, y_2].
 
@@ -80,5 +80,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalSineOperator() {
+    public void SineIntervalTest() {
       //sine depends on interval
       //sin([0, 2*pi]) = [-1, 1]
@@ -98,5 +98,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalCosineOperator() {
+    public void CosineIntervalTest() {
       //Cosine uses sine Interval.Sine(Interval.Subtract(a, new Interval(Math.PI / 2, Math.PI / 2)));
       Assert.AreEqual<Interval>(Interval.Cosine(new Interval(0, 2 * Math.PI)), new Interval(-1, 1));
@@ -107,5 +107,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalLogOperator() {
+    public void LogIntervalTest() {
       //Log([3, 5]) = [log(3), log(5)]
       Assert.AreEqual<Interval>(new Interval(Math.Log(3), Math.Log(5)), Interval.Logarithm(new Interval(3, 5)));
@@ -122,5 +122,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalExpOperator() {
+    public void ExponentialIntervalTest() {
       //Exp([0, 1]) = [exp(0), exp(1)]
       Assert.AreEqual<Interval>(new Interval(1, Math.Exp(1)), Interval.Exponential(new Interval(0, 1)));
@@ -131,5 +131,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalSqrOperator() {
+    public void SquareIntervalTest() {
       Assert.AreEqual<Interval>(new Interval(1, 4), Interval.Square(new Interval(1, 2)));
       Assert.AreEqual<Interval>(new Interval(1, 4), Interval.Square(new Interval(-2, -1)));
@@ -140,5 +140,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalSqrtOperator() {
+    public void SquarerootIntervalTest() {
       Assert.AreEqual<Interval>(new Interval(1, 2), Interval.SquareRoot(new Interval(1, 4)));
       Assert.AreEqual<Interval>(new Interval(double.NaN, double.NaN), Interval.SquareRoot(new Interval(-4, -1)));
@@ -148,5 +148,5 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalCubeOperator() {
+    public void CubeIntervalTest() {
       Assert.AreEqual<Interval>(new Interval(1, 8), Interval.Cube(new Interval(1, 2)));
       Assert.AreEqual<Interval>(new Interval(-8, -1), Interval.Cube(new Interval(-2, -1)));
@@ -157,7 +157,95 @@
     [TestCategory("Problems.DataAnalysis")]
     [TestProperty("Time", "short")]
-    public void TestIntervalCbrtOperator() {
+    public void CubeRootIntervalTest() {
       Assert.AreEqual<Interval>(new Interval(1, 2), Interval.CubicRoot(new Interval(1, 8)));
-      Assert.AreEqual<Interval>(new Interval(double.NaN, double.NaN), Interval.CubicRoot(new Interval(-8, -1)));
+      Assert.AreEqual<Interval>(new Interval(-2, -2), Interval.CubicRoot(new Interval(-8, -8)));
+      Assert.AreEqual<Interval>(new Interval(-2, 2), Interval.CubicRoot(new Interval(-8, 8)));
+      Assert.AreEqual(new Interval(2, 2), Interval.CubicRoot(new Interval(8, 8)));
+      Assert.AreEqual(new Interval(-Math.Pow(6, 1.0 / 3), 2), Interval.CubicRoot(new Interval(-6, 8)));
+      Assert.AreEqual(new Interval(2, 2), Interval.CubicRoot(new Interval(8, 8)));
+      Assert.AreEqual(new Interval(-2, 0), Interval.CubicRoot(new Interval(-8, 0)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void AbsoluteIntervalTest() {
+      Assert.AreEqual(new Interval(2, 5), Interval.Absolute(new Interval(-5, -2)));
+      Assert.AreEqual(new Interval(2, 5), Interval.Absolute(new Interval(2, 5)));
+      Assert.AreEqual(new Interval(0, 3), Interval.Absolute(new Interval(-3, 0)));
+      Assert.AreEqual(new Interval(0, 5), Interval.Absolute(new Interval(0, 5)));
+      Assert.AreEqual(new Interval(0, 5), Interval.Absolute(new Interval(-2, 5)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void AnalyticalQuotientIntervalTest() {
+      //Analytical Quotient ==> a / sqrt(b^2 + 1)
+      var aPos = new Interval(3, 5);
+      var aZero = new Interval(-3, 5);
+      var aNeg = new Interval(-5, -3);
+
+      var bPos = new Interval(2, 4);
+      var bZero = new Interval(-2, 4);
+      var bNeg = new Interval(-4, -2);
+
+      //Second interval goes over zero
+      Assert.AreEqual(new Interval(aPos.LowerBound/Math.Sqrt(17), aPos.UpperBound), Interval.AnalyticalQuotient(aPos, bZero));
+      Assert.AreEqual(new Interval(aZero.LowerBound, aZero.UpperBound), Interval.AnalyticalQuotient(aZero, bZero));
+      Assert.AreEqual(new Interval(aNeg.LowerBound, aNeg.UpperBound/Math.Sqrt(17)), Interval.AnalyticalQuotient(aNeg, bZero));
+      //Second interval is positive
+      Assert.AreEqual(new Interval(aPos.LowerBound/Math.Sqrt(17), aPos.UpperBound/Math.Sqrt(5)), Interval.AnalyticalQuotient(aPos, bPos));
+      Assert.AreEqual(new Interval(aZero.LowerBound/Math.Sqrt(5), aZero.UpperBound/Math.Sqrt(5)), Interval.AnalyticalQuotient(aZero, bPos));
+      Assert.AreEqual(new Interval(aNeg.LowerBound/Math.Sqrt(5), aNeg.UpperBound/Math.Sqrt(17)), Interval.AnalyticalQuotient(aNeg, bPos));
+      //Second interval is negative
+      Assert.AreEqual(new Interval(aPos.LowerBound/Math.Sqrt(17), aPos.UpperBound/Math.Sqrt(5)), Interval.AnalyticalQuotient(aPos, bNeg));
+      Assert.AreEqual(new Interval(aZero.LowerBound/Math.Sqrt(5), aZero.UpperBound/Math.Sqrt(5)), Interval.AnalyticalQuotient(aZero, bNeg));
+      Assert.AreEqual(new Interval(aNeg.LowerBound/Math.Sqrt(5), aNeg.UpperBound/Math.Sqrt(17)), Interval.AnalyticalQuotient(aNeg, bNeg));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void IsNegativeIntervalTest() {
+      Assert.IsTrue(new Interval(-2, -1).IsNegative);
+      Assert.IsFalse(new Interval(-2, 0).IsNegative);
+      Assert.IsFalse(new Interval(-2, 2).IsNegative);
+      Assert.IsFalse(new Interval(2, 4).IsNegative);
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void IsPositiveIntervalTest() {
+      Assert.IsTrue(new Interval(3, 5).IsPositive);
+      Assert.IsFalse(new Interval(0, 5).IsPositive);
+      Assert.IsFalse(new Interval(-1, 5).IsPositive);
+      Assert.IsFalse(new Interval(-5, -2).IsPositive);
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void IsAlmostIntervalTest() {
+      var negativeLowerBound = -2E-13;
+      var negativeUpperBound = -1E-13;
+      var positiveLowerBound = 3E-13;
+      var positiveUpperBound = 5E-13;
+
+      var negativeInterval = new Interval(negativeLowerBound, negativeUpperBound);
+      var positiveInterval = new Interval(positiveLowerBound, positiveUpperBound);
+      var zeroInterval = new Interval(negativeUpperBound, positiveLowerBound);
+
+      //Check for right-shift of negative interval
+      Assert.AreEqual(negativeUpperBound, negativeInterval.LowerBound);
+      Assert.AreEqual(negativeUpperBound, negativeInterval.UpperBound);
+      //Check for left-shift of positive interval
+      Assert.AreEqual(positiveLowerBound, positiveInterval.LowerBound);
+      Assert.AreEqual(positiveLowerBound, positiveInterval.UpperBound);
+      //Check for setting interval to zero
+      Assert.AreEqual(0, zeroInterval.LowerBound);
+      Assert.AreEqual(0, zeroInterval.UpperBound);
+
     }
   }
